*CMZ :          12/08/96  19.20.42  by  Ashot Chilingarian
*-- Author :
      SUBROUTINE KNNES(A,T,U,W,NL,DP,DEL,TRUE,WP,E,SS,N,M,MP,KCL,
     1 DIS,DEN,NT,DEBUG,JDIST)
      DIMENSION A(N*M),NL(MP,KCL),DEL(MP),E(MP)
      DIMENSION TRUE(KCL),DEN(KCL),DIS(KCL)
      DIMENSION T(N*MP),U(M),W(MP),WP(KCL),DP(MP,KCL)
c_______________________________________________________________________________
c     Estimation of "energy", linux-version
c A(N,M) - Trainig sample, M Monte-Carlo trials with NS variables + corresponden
c "energy" or some other parameter to be known from M.C. inputs and to be
c estimated in experiment.
c T(N,MP) - Control (Experimental) sample with same NS variables measured, for
c calculating MEAn SQ. DEv. of method one can use for control another or ever
c same M.C. events, so if NS+1 position the "true energy" is placed, not of
c coarse, used for estimation, but for comparison with obtained "energy".
c U(M) and W(MP) the correspondent weights arrays
c NL(MP,KCL), the order number of nearest neighbours of the control sample
c events in the TS.
c DP(MP,KCL) - correspondent distancies.
c DIS(KCL) and WP(KCL) the distances and weights for current J-th control event.
c TRUE(KCL) - the actual values of "energies" for training events, obtained from
c simulation with this parameters.
c E(MP) and DEL(MP) - the obtained estimates and discrepancies (relative errors)
c DEN(KCL) - the coefficients for weighing the summ of neighbours, 2 modes used:
c     LINEAR - inverse proportional to distance from NN and
c     SQUARE - inverse proportional to square of distance.
c     KCL - number of neighbours used.
c     SS - Mean square deviation of estimate.
c_______________________________________________________________________________
c
      character*50 JDIST
      data bound /1.e-10/
c
      NS=N-1
      DO 5 J=1,MP
      DO 25 I=1,KCL
c
      KK=NL(J,I)*N
      TRUE(I)=A(KK)
      DIS(I)=DP(J,I)
      WP(I)=U(NL(J,I))
c
      IF(DEBUG.GE.5.and.j.LE.10) then
            WRITE(NT,'(4x,''j-event i-neib. Near.   dist    wight''/
     *  3i8,2f9.4)')
     *  j,i,nl(j,i),dis(I),wp(I)
      end if
c
25    CONTINUE
      CALL VZERO(DEN,KCL)
      DO 75 I=1,KCL
       IF(DIS(I).LE.bound) THEN
         WRITE(NT,'(''DIS(I)='',E10.3,'' FOR EVENT AND KCL='',2I5
     *   ,'' now- '', e10.3)')DIS(I),J,I,bound
         DIS(I)=bound
        END IF
      if(JDIST.EQ.'LINEAR') then
                     DEN(I)=WP(I)/DIS(I)
      else if (JDIST.EQ.'SQUARE') then
                     DEN(I)=WP(I)/DIS(I)**2
      else if (JDIST.EQ.'SQRT') then
                     DEN(I)=WP(I)/SQRT(DIS(I))
      else if (JDIST.EQ.'UNIFORM') then
                     DEN(I)=WP(I)
      else
         write(nt,'('' UNKNOWN DISTANCE'',a8)') JDIST
                  STOP 93
      end if
75    CONTINUE
c
      S=VSUM(DEN,KCL)
      CALL VSCALE(DEN,1./S,DEN,KCL)
      IF(DEBUG.GE.4.and.j.LE.10) then
         WRITE(NT,'(/6x,''C(I) coefficients, and SUMM''/15f9.4)')
     *          (den(I),I=1,kcl),S
      end if

      E(J)=VDOT(TRUE,DEN,KCL)
         jn=j*n
      IF(DEBUG.GE.4.and.j.LE.10) then
         do ii=1,kcl
            WRITE(NT,7)j,E(J),t(jn),ii,DIS(Ii),DEN(Ii),TRUE(Ii)
7           FORMAT (/'For event',i5,' Estimate =',f9.4,' True=', f9.4/
     *      'for NN ',i5/
     * ,3x,' dist.   coeff.   energy '/3F9.4/)
         end do
      end if
c
5     CONTINUE
35    CONTINUE
      DO 55 J=1,MP
      JN=J*N
c
      if(t(jn).le.bound) then
       WRITE(NT,'(''true and ESTIMATE='',2E12.3,'' FOR EVENT '',I8)')
     *  T(Jn),E(J),j
        T(JN) =bound
        END IF
c
c     DEL(J)=(E(J)-T(JN))/T(JN)
c     SAMO change
       DEL(J)=(E(J)-T(JN))
c
55    CONTINUE
c
      IF(DEBUG.GE.3.and.j.LE.10) then
            WRITE(NT,'(22x,''TRUE VALUES''/10(5f9.4/))')
     *          (T(I),I=N,N*10,N)
         WRITE(NT,'(22x,''ESTIMATES''/10(5f9.4/))')
     *          (E(I),I=1,10)
17          FORMAT(10F6.2/)
      end if
      SS=0.
      DO 85 J=1,MP
      JN=J*N
      SS=SS+(E(J)-T(JN))**2
85    CONTINUE
c
      SS=SQRT(SS/(MP-1))
         WRITE(NT,'(22x,''MSE VALUE='',e12.4)')SS
      RETURN
      END
