*CMZ :          05/05/98  17.44.44  by  Ararat Vardanyan
*-- Author :
c_______________________________________________________________________________
C     Multivariate probability density nonparametric estimation
c               N - number of variables, MB - number of training patterns, MP -
c      control (experimental) patterns, L - number of different classes (models
c      ITO(L) - array with numbers of events in all classes.
c      KCL - number of different parameters of density estimates (Parzen window
c      widths or giperspher radii), KCL+1 - mean estimate, KCL+2 - adaptive.
c     A(N,MB) - training sample, T(N,MP) - control (experimental) sample.
c     U(MB) - training weights, WLUM(MP) = control weights.
c     AP(L,IAP) - apriory probabilities.
C     DEN(KCL+2) - density estimates of current event.
c     DFM(L,KCL+2,L,IAP) - Bayes error matrix.
c      F(KCL) - array of Parzen window widths or hipersphere radii.
c      DS(MP,L,KCL+2) - matrix of density estimates for all events
c      RINV(N*N*L) - inverse covariance matrix of L classes.
c      AP(IAP) -
c      DETER(L) - determinats of covariance matrixes of each class.
C
      SUBROUTINE PARZ(A,T,U,PST,DEN,RINV,DI,N,ITO,MB,L,MP,KCL,M2,D,NN
     *,WLUM,AP,IAP,F,DETER,DS,DFM,JMODE,DEBUG,JDEN,NT,expmax,strang)
c
      PARAMETER (PI=3.141592)
      CHARACTER*50 JMODE,JDEN
      DIMENSION A(N*MB),T(N*MP), AP(L,IAP), ITO(L),M2(mp),D(MB)
      DIMENSION DEN(KCL+2,L),PST(L),DFM(L,KCL+2,L,iap)
      DIMENSION F(KCL+2),DS(MP,L,KCL+2),RINV(N*N*L)
      DIMENSION DI(N),U(MB), WLUM(MP),DETER(L)
      DIMENSION MV(10),FF(10),DD(10),RR(15)
c
c           parametrs necessary for multivariate volume determination
c
      call vzero(DFM,L*(KCL+2)*L*IAP)
      REN=REAL(N)/2.
      DO 105 I=1,KCL
      MV(I)=MP
      DD(I)=1./((2.*PI)**REN*F(I)**N)
      FF(I)=0.5/(F(I)*F(I))
105   CONTINUE
         JTR=1
c
      DO 25 I25=1,MP
        IF(JMODE.EQ.'ONE-LEAVE-OUT-') THEN
         JTR=IND(i25,ito,L)
        END IF
        CALL VZERO(DEN,L*(KCL+2))
C
C*    DISTANCE CALCULATION
C
        KJ=0
      DO 15 J=1,MB
        ITR=IND(J,ITO,L)
      KI=N*(I25-1)
      DIS=0.
      DO 5 I5=1,N
      KI=KI+1
      KJ=KJ+1
      DI(I5)=T(KI)-A(KJ)
5     CONTINUE
C
      JR=N*N*(ITR-1)
C
C*    MAHALANOBIS DISTANCE CALCULATION
C
        DIS=0.
      DO 85 I=1,N
      DO 85 I1=1,N
      JR=JR+1
      DIS=DIS+RINV(JR)*DI(I)*DI(I1)
            IF(DEBUG.GE.5.) THEN
               WRITE(NT,'(5e12.4)')di(i),di(i1),rinv(jr),dis
             END IF

85    CONTINUE
C
C     'LEAVE ONE OUT FOR A TIME' TEST
C
      IF(I25.NE.J.OR.JMODE.EQ.'CLASSIFICATION') THEN

                  if(dis.eq.0.) then
                    dis=strang
		         if(debug.ge.4.) then
         WRITE(NT,'(2X,''DIST. between events'',2I6,'' =0'')')i25,J
                         end if
		  end if
C
C*       ESTIMATE DENSITY
C
               IF(JDEN.EQ.'RFIX'.OR.JDEN.EQ.'KNN') THEN
                  DIS=SQRT(DIS)
		END IF
          FM=0.
          DO 115 IL=1,KCL
c	
       IF(JDEN.EQ.'PARZ')THEN
               IF(DEBUG.GE.5.) THEN
                 WRITE(NT,'(3i3,5e12.4)')I25,ITR,JTR,DIS,EX, U(J)
               END IF
                           EX=DIS*FF(IL)
               IF(EX.GE.expmax) THEN
                           EX=expmax
               END IF
c
               FM=EXP(-EX)*DD(IL)*U(J)*DETER(ITR)
               DEN(IL,ITR)=DEN(IL,ITR)+FM
c	
        ELSE IF(JDEN.EQ.'RFIX')THEN
                           IF(DIS.LE.F(IL)) THEN
			         IF(DEBUG.GE.5.)THEN
			         WRITE(NT,'(3i3,e12.4)')I25,ITR,JTR,DIS
                                 END IF
			         FM=deter(itr)*U(J)/vol(f(il),n)
                                 DEN(IL,ITR)=DEN(IL,ITR)+FM
			   END IF
	 END IF		
115        CONTINUE
c			
         IF(JDEN.EQ.'KNN')THEN
                           D(J)=DIS
			IF(DEBUG.GE.4.)THEN
	    WRITE(NT,'(4i5/e12.4/5i5)')I25,ITR,JTR,J,DIS,(ito(i),i=1,l)
                        END IF
          END IF
        END IF
c
15     CONTINUE
c
           IF(JDEN.EQ.'KNN')THEN
	              IF(JMODE.EQ.'ONE-LEAVE-OUT-') THEN
		            d(ii)=1.e12
		      END IF
	     ii=1
	     iii=i25
	          DO ITR=1,L
c
c  THE DISTANCE TO THE EVEN WICH IS OUT FOR A MOMENT IS UNDEFINED !!!
c		
		              IF(JMODE.EQ.'ONE-LEAVE-OUT-') THEN
		                        d(iii)=1.e12
		              END IF
                        CALL   KNN(D(ii),U(ii),DEN,m2,DETER(itr),N,
     *                  ito(itr),l,KCL,ITR,NN,f)
                         ii=ii+ito(itr)
			 iii=iii+ito(itr)
	          END DO
	   END IF
c	
c CORRECTION TO THE "LEAVE_OUT" VALID ONLY FOR THE CASE OF EQUAL WIEGHTS!!!
c
c          write(nt,'(''dens:'',2i5/5f7.4)')i25,jtr,(den(i,1),i=1,kcl)
c
              IF(JMODE.EQ.'ONE-LEAVE-OUT-'.AND.JDEN.NE.'KNN') THEN
c
		    CORR=real(ito(jtr))/REAL(ito(jtr)-1)
		     DO IL=1,KCL		
		                   DEN(IL,JTR)=DEN(IL,JTR)*CORR
		     END DO
	      END IF
C
C      ADAPTIVE AND MEAN DENSITY ESTIMATES
C
          DO 325 I=1,L
                CALL UCOPY(DEN(1,I),RR,KCL)
                CALL FLPSOR(RR,KCL)
                DEN(KCL+1,I)=VSUM(RR,KCL)/KCL
                DEN(KCL+2,I)=DENMED(RR,KCL)
             IF (debug.ge.5.and.I25.LE.10) then
	         WRITE(NT,*)L,RR,DEN(KCL+2,I)
	     END IF
325    CONTINUE
C
      IF(JMODE.EQ.'CLASSIFICATION') THEN
                 DO 225 IT=1,L
                     DO 225 IL=1,KCL+2
                             DS(I25,IT,IL)=DEN(IL,IT)
225           CONTINUE
c        write(nt,'(''dens:'',2i5/7f7.4)')i25,jtr,(ds(1,1,i),i=1,kcl+2)
c
      END IF
C
C*    BAYESIAN CLASSIFICATION AND ERROR RATE ESTIMATION
C*
       DO 245 I=1,IAP
          DO 145 JJ=1,KCL+2
              do LC=1,L
                      PST(LC)=DEN(JJ,LC)*AP(LC,I)
              end do
               LL=LVMAX(PST,L)
c
                    IF (DEBUG.GE.4) THEN
                           WRITE(NT,'(2X,''EVENT-'',I6,'' TO'', I3,
     *                    '' DENSITIES '',5E10.4)')I25,LL,PST
                    END IF
C
                IF(JMODE.EQ.'CLASSIFICATION') THEN
                         DEL1=WLUM(I25)
c
c **** CLASSIFICATION RESULTS IN M22 ARRAY (ONLY FOR PARZ MODE!!!!!!!!!)
c			
			 m2(i25)=ll
                ELSE IF(JMODE.EQ.'ONE-LEAVE-OUT-') THEN
                         DEL1 = U(I25)
                END IF
c		
            DFM(LL,JJ,JTR,I)=DFM(LL,JJ,JTR,I)+DEL1
C
145                CONTINUE
245          CONTINUE
c
c
                     if(debug.ge.3.and.pst(ll).lt.strang) then
        WRITE(NT,'(''For Kernel -'',f5.2,'' STRANGE-'',I6,''  -TO'', I3,
     * '' DENSITIES :''/5E15.6)')f(kcl),I25,LL,PST
                     end if
C
25      CONTINUE
c
      RETURN
      END
