*CMZ :          28/04/97  15.49.52  by  Ararat Vardanyan
*-- Author :    Ararat A. Vardanyan   19/02/97
c_______________________________________________________________________________
C     Multivariate probability density nonparametric estimation
c               N - number of variables, MB - number of training patterns, MP -
c      control (experimental) patterns, L - number of different classes (models
c
c      KCL - number of different parameters of regression estimates (Parzen window
c      widths), KCL+1 - mean estimate, KCL+2 - adaptive.
c      A(N,MB) - training sample, T(N,MP) - control (experimental) sample.
c      U(MB) - training weights.
c      SM,SD (KCL+2) - mean and MSD regression
C      DEN(MP,kcl+2) - regression estimates of current events.
c      REG(MB) -  REGRESSAND
c      SFM(MP,KCL) -  weights matrix.
c      F(KCL) - array of Parzen window widths.
c      RINV(N*N) - inverse covariance matrix.
c      TRUE - true values of regression function
c      DETER - determinats of covariance matrixes of each class.
c
      SUBROUTINE REGR(A,T,U,SM,DEN,RINV,DI,N,ITO,MB,L,MP,KCL
     *,TRUE,SD,F,DETER,REG,SFM,DEBUG,NT,Y,
     * expmax,strang,jmode)
c
      PARAMETER (PI=3.141592)
c
      DIMENSION A(N*MB),T(N*MP),Y(KCL),ito(L)
      DIMENSION DEN(MP,kcl+2),SM(KCL+2),SD(KCL+2)
      DIMENSION SFM(MB,KCL)
      DIMENSION F(KCL),RINV(N*N*L),REG(MB)
      DIMENSION DI(N),U(MB),TRUE(MP),DETER(L)
      character*8 jmode
C
      CALL VZERO(DEN,MP*(KCL+2))
c
c           parametrs necessary for multivariate volume determination
c
         DD=2.*PI**(REAL(N)/2.)
c
       DO 25 I25=1,MP
      call vzero(SFM,MB*KCL)
      call vzero(SM,KCL)
C                               *********
C*     DISTANCE CALCULATION
C                               *********
        KJ=0
        DO 15 J=1,MB
c
         KI=N*(I25-1)
         ITR=IND(J,ITO,L)
c
        DO 5 I5=1,N
          KI=KI+1
          KJ=KJ+1
          DI(I5)=T(KI)-A(KJ)
5     CONTINUE
C                              *********
C*    MAHALANOBIS DISTANCE CALCULATION
C                              *********
        JR=N*N*(ITR-1)
        DIS=0.
        DO 85 I=1,N
        DO 85 I1=1,N
          JR=JR+1
          DIS=DIS+RINV(JR)*DI(I)*DI(I1)
85      CONTINUE
C
C*     REGRESSION COEFFICIENTS CALCULATION
C
        DO 115 IL=1,KCL
c
               EX=DIS*F(IL)*F(IL)
             IF(EX.GE.expmax) THEN
                IF(DEBUG.GE.2.) THEN
                  WRITE(NT,'(2i3,5e15.6)')I25,itr,DIS,
     *             f(il),EX,dd,deter(itr)
                 END IF
                EX=expmax
             END IF
c
               FM=EXP(-EX)*U(J)/DETER(ITR)/DD
c                FM=EXP(-EX)/DD
                SFM(J,IL)=SFM(J,IL)+FM
                SM(IL)=SM(IL)+FM
115        CONTINUE
c
15     CONTINUE
c
c       IF (I25.LE.10.and.debug.ge.8.) then
c         WRITE(nt,'(2x,''event '',i5,'' Summ'',9e12.4)')
c     *i25,(sm(ii),ii=1,kcl)
c       END IF
c
          DO I=1,kcl
             IF(sm(i).LE.strang) THEN
                IF(DEBUG.GE.2.) THEN
               WRITE(NT,'(i3,5e15.6)')I25,f(i),dis,sm(i),strang
                END IF
                sm(i)=strang
             END IF
          END DO
c
          do I=1,MB
            do IL=1,KCL
               SFM(I,IL)= SFM(I,IL)/SM(IL)
            end do
          end do
c
         do IL=1,KCL
          do I=1,MB
         DEN(I25,il) = DEN(I25,il)+SFM(I,IL)*REG(i)
            end do
            y(il)=DEN(I25,il)
          end do
c       IF (I25.LE.10.and.debug.ge.8) then
c       WRITE(nt,'(6x,i5,10f6.2)')
c     * I25, (den(i25,ii), ii=1,kcl)
c        end if

C
C      ADAPTIVE AND MEAN DENSITY ESTIMATES
C
      CALL FLPSOR(Y,KCL)
      DEN( I25,kcl+1)=VSUM(Y,KCL)/KCL
      DEN(I25,KCL+2) =DENMED(Y,KCL)
c       IF (I25.LE.10.and.debug.ge.8) then
c       WRITE(8,'(6x,i5,''true '',f6.2/9f6.2)')
c c    * I25,TRUE(I25), (y(ii), ii=1,kcl),DEN( I25,kcl+1)
c        end if
25      CONTINUE
C
       if(jmode.ne.'REGRO-EX') then
      call vzero(SM,KCL+2)
      call vzero(SD,KCL+2)
c
      DO 225 I=1,KCL+2
      DO 225 J=1,MP
        DEL=DEN(j,i)-TRUE(J)
        SM(I)=SM(I)+DEL/mp
        SD(I)=SD(I)+DEL*DEL
225   CONTINUE
         DO  I=1,KCL+2
           SD(I)=sqrt(SD(I)/(mp-1))
         END DO
         end if
      RETURN
      END
