*CMZ :          24/03/99  18.07.36  by  Ararat Vardanyan
*-- Author :    Ashot Chilingarian   06/04/95
C-----------------------------------------------------------------------
C NTREAD reads a HBOOK-Ntuple. Cuts may be applied on each parameter.
C It is possible to skip events or to read them in a selected order.
C A subset of parameters may be chosen. Those events that were chosen
C to be read and survived the cuts will be returned, including the
C corresponding weights and the order after which they were read.
c
      SUBROUTINE RNOMAD(NTID,LUNHB,LUNMSG,DEBUG,DSNHB,NPARMX,
     +                NPARAC,NEVTAC,NEVRD,NEVTSK,NUMBEV,CHNAMS,
     +                PARCTL,PARCTU,EVTWT,EVENTS
     *                ,opmode,ntlrec,ch)

* in the following * and C indicate INPUT and OUTPUT, respectively.

*...NTID  : Identifier (ID) of the Ntuple to be read
*...LUNHB : HBOOK - Unit
*...LUNMSG: Unit for messages according to verbose-level DEBUG
*...DEBUG : verbose-level (0...5)
*...DSNHB : HBOOK - Filename
*...NPARMX: Maximum number of parameters (NBAN)
*...NPARAC: Actual number of parameters (to be used)
*...NEVTAC: REQUIRED number of events (to be read)
C...NEVRD : Nr of events actually read
*...NEVTSK: Number of events to be skipped
*...NUMBEV: Vector of parameter-numbers to be used
C...CHNAMS: CHAR*8-Vector of corresponding parameter-descriptors (names)
*...PARCTL: Vector containing LOWER cuts on parameters
*...PARCTU: Vector containing UPPER cuts on parameters
C...EVTWT : Vector containing event WEIGHTS
C...EVENTS: Array containing the events in terms of the chosen parameters

c
       COMMON /PAWC/ MEMOR(200000)
C
      DIMENSION EVENTS(NPARAC*nevtac), EVTWT(nevtac)
      DIMENSION PARCTL(NPARMX), PARCTU(NPARMX)
      DIMENSION NUMBEV(NPARAC)
      dimension rlow(34),rhigh(34)
c
      LOGICAL   LCUT
      CHARACTER*50 DSNHB, TUPNAM
      CHARACTER*8 CHNAMS(NPARMX),ch(nparmx),hname

C... CWN need COMMONs to communicate
      REAL          V1,V2,V3,V4,V5,V6,V7,V8,V9,V10,V11,V12,V13,V14,V15,
     +              V16,V17,V18,V19,V20,V21,v22,v23,v24,v25,v26,v27,
     +              v28,v29,v30,v31,v32,v33,v34
      COMMON /V/    V1,V2,V3,V4,V5,V6,V7,V8,V9,V10,V11,V12,V13,V14,V15,
     +              V16,V17,V18,V19,V20,V21,v22,v23,v24,v25,v26,v27,
     +              v28,v29,v30,v31,v32,v33,v34
C... to fully exploit CWNs, booking is best NOT done with arrays.
C... However, arrays are MUCH more convenient, therefore:
      REAL VEQ(34)
      EQUIVALENCE (VEQ(1),V1)
C... into CH the variable names are loaded, into CHNAMS only those
C... which are used are copied. This enables selective Ntuple reading.
c
c      COMMON /SHOCHA/ CH
      CHARACTER*1 opmode
      DATA hname/'MC'/

c
c         lrec=0
c
c       FOR HUGE Ntuples -
c
c        iquest(10)=65000
c
         call HROPEN(lunhb,hname,dsnhb,opmode,ntlrec,istat)
c
        if (istat.eq.0.and.debug.ge.3) then
        write(LUNMSG,'(''Opened, with names,lun,id,rec:'',2a50/3i5,a5)')
     *   hname,dsnhb,lunhb,ntid,ntlrec,opmode
        else if(istat.ne.0) then
         write(LUNMSG,'(''ntuple open failed'')')
         write(LUNMSG,'(''names,lun,id,rec,opmod:'',2a50/3i5,a5)')
     *   hname,dsnhb,lunhb,ntid,ntlrec,opmode
         end if
c
C... get Ntuple into PAWC, print header.
c
      CALL HRIN (ntid,999,0)
c      CALL HCDIR ('//PAWC/MC',' ')
c
      if(debug.ge.5) then
      CALL HPRNTU(ntid)
       end if
c
        call HGIVEN(ntid,tupnam,nparmx,ch,rlow,rhigh)
        if (debug.ge.3) then
        write(LUNMSG,'(''Ntuple name and ID, dimension:  '',a20,2i6)')     *   tupnam, ntid,nparmx
        end if
c
        if(debug.ge.5) then
        write(LUNMSG,'(10(5a8/))')ch
        write(LUNMSG,'(10(5e8.2/))')rlow
        write(LUNMSG,'(10(5e8.2/))')rhigh
        end if
c
C... copy variable names which are used to vector CHNAMS
      DO 2 J = 1,NPARAC
         CHNAMS(J) = CH(NUMBEV(J))
   2  CONTINUE
C... take care that weights are read
      CHNAMS(NPARAC+1) = 'weit'
c
c ********* REQUESTED NUMBER OF EVENTS TO BE READ FROM NTUPLE ************
c
        nexist=nevtac
c
C... Get number of events in Ntuple
c
c
      CALL HNOENT(NTID,NOENT)
      IF (NEVTAC.GT.NOENT) THEN
          IF(DEBUG.GE.5.) then
         write(LUNMSG,'(''Events, requested and available'',2i7)')
     *nevtac,noent
          END IF
c
c ******** CHANGE the requested number of events to really available *****
c ********                  from PAW ntuple                          *****
c
           nexist=noent
c
      ENDIF
c
C----------------------------------------------------------------------
C... Loop over events, read parameters
      NEV = 0
      DO 10 I = 1,Nexist
C
C... Read events in incremental order, skipping the first
C... NEVTSK ones
            J = I + NEVTSK
c
C... actual Ntuple read-routine => V1,... EQUIV VEQ(1),...
c
         call HGNPAR(ntid,'aram')
         call hgnf(ntid,j,v1,ierr)
c
C... cuts on parameters
C...
c *************** CHECKING OF ALL PARAMETERS INSTED OF ONLY USED IN ANALYSIS **
c                            (04.09.98, Yerevan)
C
         LCUT = .FALSE.
         DO 5 JJ = 1,NPARMX
C... set flag LCUT if cuts apply
            IF (VEQ(JJ).LT.PARCTL(JJ).OR.
     +          VEQ(JJ).GT.PARCTU(JJ)) THEN
                        LCUT = .TRUE.
              if (nexist.le.10) then
            write(lunmsg,'(''event and param'',2i8/3e12.4)')
     *            j, jj,veq(jj),parctl(jj),parctu(jj)
              end if
            END IF
   5     CONTINUE
C... if cuts didn't apply, store event number and increment
C... event counter
c
         IF (.NOT.LCUT) THEN
c
          do jj=1,nparac
              EVENTS(nev*nparac+jj) = VEQ(NUMBEV(JJ))
          end do
c
            NEV = NEV + 1
            EVTWT(NEV)    = 1.
c            EVTORO(NEV) = J
         ENDIF
c
         IF (debug.ge.6.and.events((nev-1)*nparac+2).
     *   ne.veq(numbev(2))) THEN
            write(lunmsg,'(i7,''alf=    '',f7.2)')
     *     j,events((nev-1)*nparac+2)
c     *           (events(ii),ii=(nev-1)*nparac+1,nev*nparac)
         ENDIF
  10  CONTINUE
C----------------------------------------------------------------------
c
C... in case cuts applied to the LAST event, delete this entry
c      IF (LCUT) THEN
c         DO 20 JJ = 1,NPARAC
c            EVENTS(NEV*nparac + jj) = 0.0
c
c  20     CONTINUE
c      ENDIF
c
C... events actually read <- event counter
      NEVRD = NEV
c
C... normal HBOOK closing procedure
c

       CALL HREND(hname)
       CALL HREND('aram')
c
c      CALL HDELET (0)
c      CALL HSCR(0,0,' ')
c
      CLOSE(LUNHB)
c
      CLOSE (NTID)
c
C... The end.
      RETURN
      END








